#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;

#define MAXN 100100

int N, A[MAXN], viz[MAXN], nr[2];
vector<int> G[MAXN], C[MAXN];

void dfs(int x)
{
    int i;
    for(i = 0; i < G[x].size(); i++)
     if(!viz[ G[x][i] ])
     {
        viz[ G[x][i] ] = 1;
        A[ G[x][i] ] = (A[x] + C[x][i]) & 1;
        nr[ A[G[x][i]] ]++;
        dfs(G[x][i]);
     }
}

int main(void)
{
    int i, j, k, c;

    freopen("plopi.in", "rt", stdin);
    freopen("plopi.out", "wt", stdout);

    scanf("%d\n", &N);
    for(i = 1; i < N; i++)
    {
        scanf("%d %d %d", &j, &k, &c);
        G[j].push_back(k);
        G[k].push_back(j);
        C[j].push_back(c&1);
        C[k].push_back(c&1);
    }
    viz[1] = 1, nr[0] = 1;
    dfs(1);
	
    printf("%I64d\n", (long long)N*(N-1)/2-(long long)nr[0]*(nr[0]-1)/2-(long long)nr[1]*(nr[1]-1)/2);
    return 0;
}


