#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;

#define MAXN 100100

int N;
vector<int> G[MAXN], C[MAXN];
int viz[MAXN], nr[MAXN];

void dfs(int x)
{
    int i;
    for(i = 0; i < G[x].size(); i++)
     if(!viz[G[x][i]])
     {
        viz[G[x][i]] = 1;
        nr[G[x][i]] = (nr[x] + C[x][i]) & 1;
        dfs(G[x][i]);
     }
}

int main(void)
{
    int a, b, c, i, j;

    freopen("plopi.in", "rt", stdin);
    freopen("plopi.out", "wt", stdout);

    scanf("%d", &N);

    for(i = 1; i < N; i++)
    {
        scanf("%d %d %d", &a, &b, &c);
        G[a].push_back(b);
        G[b].push_back(a);
        C[a].push_back(c);
        C[b].push_back(c);
    }

    long long ret = 0;
    for(i = 1; i <= N; i++)
    {
        memset(viz, 0, sizeof(viz));
        memset(nr, 0, sizeof(nr));
        viz[i] = 1;
        dfs(i);
        for(j = 1; j <= N; j++)
            if(nr[j] == 1)
                ret++;
    }

    printf("%lld\n", ret/2);

    return 0;
}


